/*
 * File: FlipVertical.js
 * ---------------------
 * This program tests the flipVertical method from Chapter 8.
 */

"use strict";

/* Constants */

const GWINDOW_WIDTH = 500;
const GWINDOW_HEIGHT = 300;
const IMAGE_SEP = 100;

/* Main program */
function FlipVertical() {
   let callback = function(dataURL) {
      let original = GImage(dataURL);
      let processOriginal = function() {
         let flipped = flipVertical(original);
         let processFlipped = function() {
            let gw = GWindow(GWINDOW_WIDTH, GWINDOW_HEIGHT);
            let cx = gw.getWidth()/2;
            let cy = gw.getHeight()/2;
            let ulx1 = cx - (original.getWidth() + flipped.getWidth() + IMAGE_SEP)/2;
            let ulx2 = ulx1 + original.getWidth() + IMAGE_SEP;
            gw.add(original, ulx1, cy - original.getHeight()/2);
            gw.add(flipped, ulx2, cy - flipped.getHeight()/2);
         };
         flipped.addEventListener("load", processFlipped);
      };
      original.addEventListener("load", processOriginal);
   }
   JSFileChooser.chooseDataFile(callback);
}

/*
 * Creates a new image which consists of the bits in the original
 * flipped vertically around the center line.
 */
function flipVertical(image) {
   return GImage(image.getPixelArray());
}
